package com.cynt.upload;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

/**
 * <p>Title: File Upload</p>
 * <p>Description:  ε Ŭ</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CYNT</p>
 * @author ̸
 * @Date 2002/10/04
 * @version 1.0
 * @add(2002.10.10)
 * 		1.  getAllParameter(),getAllFileParameter()
 * 		2.  Hashtable ĶͿ  Ķ͸   .
 * @add(2002.10.21)
 * 		1.  getAllFileCollection()
 * @license
 * 		1. ε ҽ   Ͽ Ҽ   α׷  մϴ.
 * 			(۱  κ Դϴ)
 *		2. ε  ۱ úκ Ѽϸ ȵ˴ϴ.
 *  	   (۱ ǥô ε  ۼ ĸ մϴ.   մϴ)
 *      3. Ÿ ǹ http://www.javasun.net  ̿ ֽñ ٶϴ.
 *		   (   Ϸ  ʽϴ)
 */

public class YueSsahUpload{
  private Hashtable parameters = new Hashtable();
  private Hashtable fileParameters = new Hashtable();
  private Vector vc = new Vector();
  private DataInputStream servletIn = null;
  private FileOutputStream fileOut = null;
  private File saveFile = null;
  private String fileName = null;
  private String encode_1;
  private String encode_2;
  private long maxFileSize = 1024*1024*3;//3M
  private int contentLength = 0;
  private String bound = "";
  private String saveDir = "";
  private final String nameHeader = new String("Content-Disposition: form-data; name=");
  
  //File logFile = new File("c:/HTTPlog.txt");
  //FileWriter fw;
  private boolean VERBOSE = false;
  public YueSsahUpload() {
  	//try{fw = new FileWriter(logFile);}catch(Exception e){}
  }
  public YueSsahUpload(int maxFileSize) {
    this.maxFileSize = maxFileSize;
  }

  public void getRequest(HttpServletRequest req) throws Exception{
    try{
      servletIn = new DataInputStream(req.getInputStream());
      bound = getBoundary(req.getContentType());
      contentLength = req.getContentLength(); 
      makeParameters();
    }
    finally
    {
    	try{servletIn.close();}catch(Exception ex){}
    }
  }

  public void setEncode(String enc1,String enc2){
  	encode_1 = enc1;
  	encode_2 = enc2;
  }
  public void setEncode(String enc1){
  	encode_1 = enc1;
  }
  public void setMaxFileSize(int fileSize){
	maxFileSize = (long)(fileSize*1024*1024);
  }

  private String getBoundary(String line) throws Exception{
    int from = line.indexOf("boundary=");
    return ("--"+line.substring(from+9));
  }

  private void makeParameters() throws Exception {
    String line = "";
    String subLine = "";
	try
	{
		servletIn.readLine();
   		while(true){
      	if((line = servletIn.readLine())  == null){
      		break;
      	}
      	if(line.indexOf(nameHeader) != -1){
        	subLine = servletIn.readLine();
        	if(subLine.indexOf("Content-Type") != -1){
          		saveFile(line);
          		servletIn.readLine();
        	}
        	else{
          		addParameter(line);
        	}
      	}
      	//else break;
    	}//while
    }
    finally
    {
    	
    }	
  }

  public void setSaveDir(String dir){
    File createDir = new File(dir);
    if(!createDir.exists()) createDir.mkdirs();
    char otherSeparator;
    otherSeparator = File.separatorChar == '/' ? '\\' : '/';
    this.saveDir = dir.replace(otherSeparator, File.separatorChar);
  }
  
  private void addParameter(String line) throws Exception{
    String pName = line.substring(38,line.length()-1);
    String pValue = "";
    StringBuffer imsi = new StringBuffer();

    while((pValue = servletIn.readLine()) !=null){
      if(pValue.indexOf(bound)!= -1) break;
      else{
        imsi.append(pValue+"\n");
      }
    }
	if(encode_1 == null) parameters.put(pName,new String(imsi.toString().trim()));
	else if(encode_1 != null && encode_2 == null) parameters.put(pName,new String(imsi.toString().trim().getBytes(encode_1)));
	else parameters.put(pName,new String(imsi.toString().trim().getBytes(encode_1),encode_2));
  }
  
  public String getParameter(String pkey) throws Exception{
  	if(!parameters.containsKey(pkey)){
  		throw new Exception("Input Parameter Name Error! name:"+pkey);
  	}
    return parameters.get(pkey).toString();
  }
  
  public File getFile(String pkey) throws Exception{
    if(!fileParameters.containsKey(pkey)){
                  throw new Exception("Input Parameter Name Error! name:"+pkey);
          }
    if((fileParameters.get(pkey).toString()).equals("")) return null;
    return (File)fileParameters.get(pkey);
  }
  
  public Enumeration getAllParameter() throws Exception{
    return parameters.keys();
  }
  
  public Enumeration getAllFileParameter() throws Exception{
    return fileParameters.keys();
  }
  public Collection getAllFileCollection() throws Exception{
  	Hashtable returnTable = new Hashtable();
    Enumeration en = fileParameters.keys();
    String para;
    while(en.hasMoreElements())
    {
    	para = (String)en.nextElement();
    	if(fileParameters.get(para).equals("")) continue;
    	returnTable.put(para,fileParameters.get(para));
    }
    return returnTable.values();
  }
  
  private void saveFile(String line) throws Exception{
    byte[] buffer=new byte[1024];
    byte ch;
    long gfilesize = 0;
    int lineNum = 0;
    int x=0;

    String pName = line.substring(38,line.lastIndexOf(";")-1);
    if((lineNum = line.indexOf(" filename=")) != -1){
      fileName = line.substring(line.lastIndexOf(";")+12,line.length()-1);
      if(fileName == null || fileName.trim().equals(""))
      {
      	fileParameters.put(pName,"");
      	return;
      }
      if(encode_1 == null) fileName = new String(fileName.substring(fileName.lastIndexOf("\\")+1));
	  else if(encode_1 != null && encode_2 == null) fileName = new String(fileName.substring(fileName.lastIndexOf("\\")+1).getBytes(encode_1));
	  else fileName = new String(fileName.substring(fileName.lastIndexOf("\\")+1).getBytes(encode_1),encode_2);
	
    }
    else return;

    existCheck(); 

    fileOut = new FileOutputStream(saveFile);
    servletIn.readLine();


    while(true){
      buffer[x++]=ch=servletIn.readByte();
      gfilesize++;

      uploadFileSizeCheck(gfilesize);

      if(x==bound.length()+1){
        int y=0;
        String end2=new String(buffer,0,x);
        y=end2.indexOf(bound);

        if(y!=-1){
          x=y;
          if(x!=0)fileOut.write(buffer,0,x-1);
          break;
        }
      }
      else{
        if(x==1023||ch=='\n'){
          fileOut.write(buffer,0,x);
          x=0;
        }
      }
    }
    fileOut.close();
    
    if(saveFile.length()==2)
    {
    	fileParameters.put(pName,"");
    	return;
    }
    System.out.println("gfilesize:"+gfilesize);
    System.out.println("saveFile:"+saveFile.length());
    fileParameters.put(pName,saveFile);
  }
  
  private void existCheck() throws Exception{
    String fileFullName = "";
    String lastValue = "";
    int lastNum = 0;
    String firstName = "";
    String extendName = "";
    fileFullName = saveDir+fileName;
    saveFile = new File(fileFullName);
    if(saveFile.exists()){
      fileRename(saveDir,fileName);
    }
    vc.addElement(saveFile);
  }
  
  private void fileRename(String dir,String oldFileName) throws Exception{
    StringBuffer newFileName = new StringBuffer(oldFileName);
    String strIndexNum = "";
    int indexNum = 0;
    while(true){
      if(oldFileName.indexOf(".") != -1){
        strIndexNum = oldFileName.substring(oldFileName.indexOf(".")-2,oldFileName.indexOf("."));
        try{
          indexNum = Integer.parseInt(strIndexNum);
          strIndexNum = (indexNum++)<10?("0"+indexNum):(indexNum+"");
          newFileName = newFileName.replace(oldFileName.indexOf(".")-2,oldFileName.indexOf("."),strIndexNum);
        }catch(Exception e){
          strIndexNum = "00";
          newFileName = newFileName.insert(oldFileName.indexOf("."),strIndexNum);
        }
      }
      else{
        strIndexNum = oldFileName.substring(oldFileName.length()-2);
        try{
          indexNum = Integer.parseInt(strIndexNum);
          strIndexNum = (indexNum++)<10?("0"+indexNum):(indexNum+"");
          newFileName = newFileName.replace(oldFileName.length()-2,oldFileName.length(),strIndexNum);
        }catch(Exception e){
          strIndexNum = "00";
          newFileName = newFileName.insert(oldFileName.length(),strIndexNum);
        }
      }
      saveFile = new File(dir+newFileName.toString());
      oldFileName = newFileName.toString();
      if(!saveFile.exists()) break;
    }//end while
  }
  
  private void uploadFileSizeCheck(long filesize) throws Exception{
    if(maxFileSize <= filesize){
      //System.out.println(maxFileSize+"::"+filesize);
      fileOut.close();
      servletIn.close();
      if(saveFile.exists())
      {
        if(saveFile.delete()) if(VERBOSE) System.out.println("ϻϷ");
      }
      if(!vc.isEmpty()){
      	for(int i=0;i<vc.size();i++){
      	  File delFile = (File)vc.elementAt(i);
      	  if(delFile.exists()){
      	  	if(delFile.delete()) if(VERBOSE) System.out.println("ϻϷ");
      	  }
      	}
      	vc = null;
      }
      throw new IOException("File size error["+(maxFileSize/1024/1024)+"M]");
    }
  }

  public static void main(String[] args) {
    YueSsahUpload YueSsahUpload1 = new YueSsahUpload();
  }
}
